Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/raster/impl/DefaultCoverageStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/raster/impl/DefaultCoverageStore.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/raster/impl/DefaultCoverageStore.java	(revision 44259)
@@ -71,6 +71,7 @@
 import org.gvsig.tools.persistence.PersistentState;
 import org.gvsig.tools.persistence.exception.PersistenceException;
 import org.gvsig.tools.undo.command.Command;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 import org.gvsig.tools.visitor.Visitor;
 
 /**
@@ -149,28 +150,11 @@
 	}
 
 
-	/* (non-Javadoc)
-	 * @see org.gvsig.fmap.dal.DataStore#getChildren()
-	 */
-	public Iterator getChildren() {
-		return this.provider.getChildren();
-	}
-
         @Override
-        public DataStore getChild(String name) {
-            return null;
-        }
-
-        @Override
-        public List<String> getChildrenNames() {
-            return Collections.EMPTY_LIST;
-        }
+	public UnmodifiableBasicMap<String,DataStore> getChildren() {
+		return UnmodifiableBasicMap.EMPTY_UNMODIFIABLEBASICMAP;
+	}
         
-        @Override
-        public boolean hasChildren() {
-            return false;
-        }
-        
 	/* (non-Javadoc)
 	 * @see org.gvsig.fmap.dal.DataStore#getDataSet()
 	 */
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultFeatureSymbolTable.java	(revision 44259)
@@ -1,8 +1,11 @@
 package org.gvsig.fmap.dal.impl.expressionevaluator;
 
 import org.apache.commons.lang3.Range;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
+import org.gvsig.expressionevaluator.ExpressionRuntimeException;
+import org.gvsig.expressionevaluator.ExpressionUtils;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
@@ -17,7 +20,9 @@
 import org.gvsig.fmap.dal.feature.FeatureSelection;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
+import static org.gvsig.fmap.dal.impl.expressionevaluator.DALSymbolTable.FUNCTION_FEATURES;
 import org.gvsig.fmap.dal.impl.expressionevaluator.DALSymbolTable.FeaturesFunction;
+import org.gvsig.tools.dynobject.Tags;
 import org.gvsig.tools.script.Script;
 import org.gvsig.tools.util.UnmodifiableBasicList;
 
@@ -25,8 +30,69 @@
  *
  * @author jjdelcerro
  */
+    @SuppressWarnings("UseSpecificCatch")
 public class DefaultFeatureSymbolTable extends AbstractSymbolTable implements FeatureSymbolTable {
-    
+
+    public static final String FUNCTION_FOREING_VALUE = "FOREING_VALUE";
+
+    public class ForeingValueFunction extends AbstractFunction {
+
+        public ForeingValueFunction() {
+            super(
+                    "Data access",
+                    FUNCTION_FOREING_VALUE,
+                    Range.is(1),
+                    "Return the value of a field throw a relation from other tables.",
+                    FUNCTION_FOREING_VALUE + "({{field_name}})",
+                    new String[]{
+                        "fieldName - dot separated field path"
+                    },
+                    "OBJECT"
+            );
+        }
+
+        @Override
+        public Object call(Interpreter interpreter, Object[] args) throws Exception {
+            ExpressionBuilder builder = ExpressionUtils.createExpressionBuilder();
+            String fullFieldName = getStr(args, 0);
+            String[] nameParts = fullFieldName.split("[.]");
+            Feature currentFeature = feature;
+            try {
+                String namePart;
+                Object value;
+                for (int i = 0; i < nameParts.length-1; i++) {
+                    namePart = nameParts[i];
+                    value = currentFeature.get(namePart);
+                    
+                    FeatureAttributeDescriptor attrdesc = currentFeature.getType().getAttributeDescriptor(namePart);
+                    Tags tags = attrdesc.getTags();
+                    String storeName = tags.getString(DataManager.DAL_FOREING_TABLE, null);
+                    String attrName = tags.getString(DataManager.DAL_FOREING_CODE, null);
+
+                    StoresRepository repository = currentFeature.getStore().getStoresRepository();
+                    FeatureStore store = (FeatureStore) repository.get(storeName);
+                    currentFeature = store.findFirst(
+                            builder.eq(
+                                    builder.constant(value), 
+                                    builder.variable(attrName)
+                            ).toString()
+                    );
+                    if( currentFeature==null ) {
+                        return null;
+                    }
+                }
+                namePart = nameParts[nameParts.length-1];
+                value = currentFeature.get(namePart);
+                return value;
+            } catch (ExpressionRuntimeException ex) {
+                throw ex;
+            } catch (Exception ex) {
+                throw new ExpressionRuntimeException("Problems calling '" + FUNCTION_FEATURES + "' function", ex);
+            }
+        }
+        
+    }
+
     private class LocalFeaturesFunction extends FeaturesFunction {
 
         public LocalFeaturesFunction() {
@@ -37,13 +103,13 @@
         protected DataStore getStore(String storeName) {
             DataManager dataManager = DALLocator.getDataManager();
             DataStore store = null;
-            if( feature!=null ) {
+            if (feature != null) {
                 store = feature.getStore();
-                store = store.getChild(storeName);
+                store = store.getChildren().get(storeName);
             }
-            if( store == null ) {
+            if (store == null) {
                 StoresRepository repository = dataManager.getStoresRepository();
-                if( repository.containsKey(storeName) ) {
+                if (repository.containsKey(storeName)) {
                     store = repository.get(storeName);
                 }
             }
@@ -90,7 +156,7 @@
 
         @Override
         public Object call(Interpreter interpreter, Object[] args) throws Exception {
-            if( feature==null ) {
+            if (feature == null) {
                 return null;
             }
             return feature.getStore();
@@ -115,7 +181,7 @@
 
         @Override
         public Object call(Interpreter interpreter, Object[] args) throws Exception {
-            if( feature==null ) {
+            if (feature == null) {
                 return false;
             }
             FeatureStore store = feature.getStore();
@@ -136,6 +202,7 @@
         this.addFunction(new FeatureStoreFunction());
         this.addFunction(new IsSelectedFunction());
         this.addFunction(new LocalFeaturesFunction());
+        this.addFunction(new ForeingValueFunction());
     }
 
     @SuppressWarnings("OverridableMethodCallInConstructor")
@@ -159,7 +226,7 @@
 
     @Override
     public boolean exists(String name) {
-        if (type!=null && type.get(name) != null) {
+        if (type != null && type.get(name) != null) {
             return true;
         }
         return false;
@@ -167,7 +234,7 @@
 
     @Override
     public Object value(String name) {
-        if( feature==null ) {
+        if (feature == null) {
             return null;
         }
         return this.feature.get(name);
@@ -175,14 +242,14 @@
 
     @Override
     public boolean isSQLCompatible(String name) {
-        if( this.type == null ) {
+        if (this.type == null) {
             return super.isSQLCompatible(name);
         }
         FeatureAttributeDescriptor attrdesc = this.type.getAttributeDescriptor(name);
-        if( attrdesc == null ) {
+        if (attrdesc == null) {
             return true;
         }
-        if( attrdesc.isComputed() ) {
+        if (attrdesc.isComputed()) {
             return false;
         }
         return true;
@@ -203,7 +270,6 @@
         return symbolTable;
     }
 
-    
     public static void selfRegister() {
         ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
         manager.registerSymbolTable(new DefaultfeatureSymbolTableFactory());
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultStoresRepository.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultStoresRepository.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultStoresRepository.java	(revision 44259)
@@ -8,6 +8,8 @@
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.StoresRepository;
 import org.gvsig.tools.util.GetItemByKey;
+import org.gvsig.tools.util.UnmodifiableBasicSet;
+import org.gvsig.tools.util.UnmodifiableBasicSetAdapter;
 
 /**
  *
@@ -91,8 +93,25 @@
     }
 
     @Override
-    public Iterator<String> iterator() {
-        return this.repository.keySet().iterator();
+    public Iterator<DataStore> iterator() {
+        final Iterator<String> it = this.keySet().iterator();
+        return new Iterator<DataStore>() {
+            @Override
+            public boolean hasNext() {
+                return it.hasNext();
+            }
+
+            @Override
+            public DataStore next() {
+                String name = it.next();
+                return get(name);
+            }
+        };
     }
     
+    @Override
+    public UnmodifiableBasicSet<String> keySet() {
+        return new UnmodifiableBasicSetAdapter(this.repository.keySet());
+    }
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/SelectableForeingKey.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/SelectableForeingKey.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/SelectableForeingKey.java	(revision 44259)
@@ -4,12 +4,12 @@
 import org.gvsig.expressionevaluator.ExpressionUtils;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_CODE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_TABLE;
 import org.gvsig.fmap.dal.feature.AbstractDataProfile;
 import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureStore;
-import static org.gvsig.fmap.dal.impl.dataprofile.ForeingKey.DAL_FOREING_CODE;
-import static org.gvsig.fmap.dal.impl.dataprofile.ForeingKey.DAL_FOREING_TABLE;
 import org.gvsig.tools.dynobject.Tags;
 
 /**
@@ -20,7 +20,7 @@
 public class SelectableForeingKey extends AbstractDataProfile {
     
     public SelectableForeingKey() {
-        super("DAL.SelectableForeingKey", "Selectable foreing key", Feature.class);
+        super(DataManager.DAL_SELECTABLE_FOREING_KEY, "Selectable foreing key", Feature.class);
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/ForeingKey.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/ForeingKey.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/dataprofile/ForeingKey.java	(revision 44259)
@@ -4,6 +4,8 @@
 import org.gvsig.expressionevaluator.ExpressionUtils;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_CODE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_TABLE;
 import org.gvsig.fmap.dal.feature.AbstractDataProfile;
 import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
@@ -17,12 +19,8 @@
 @SuppressWarnings("UseSpecificCatch")
 public class ForeingKey extends AbstractDataProfile {
     
-    public static final String DAL_FOREING_CODE = "DAL.foreingCode";
-    public static final String DAL_FOREING_TABLE = "DAL.foreingTable";
-    public static final String DAL_FOREING_LABEL = "DAL.foreingLabel";
-
     public ForeingKey() {
-        super("DAL.ForeingKey", "Foreing key", Feature.class);
+        super(DataManager.DAL_FOREING_KEY, "Foreing key", Feature.class);
     }
 
     @Override
@@ -31,8 +29,8 @@
             return null;
         }
         try {
-            String foreingTableName = (String) tags.get(DAL_FOREING_TABLE);
-            String foreingCodeName = (String) tags.get(DAL_FOREING_CODE);
+            String foreingTableName = tags.getString(DAL_FOREING_TABLE,null);
+            String foreingCodeName = tags.getString(DAL_FOREING_CODE, null);
             
             DataManager dataManager = DALLocator.getDataManager();
             FeatureStore store = (FeatureStore) dataManager.getStoresRepository().get(foreingTableName);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java	(revision 44259)
@@ -260,7 +260,7 @@
                 hasStrongChanges = true;
             }
         }
-        this.name = name;
+        super.setName(name);
         if (!isComputed()) {
             hasStrongChanges = true;
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureStore.java	(revision 44259)
@@ -58,6 +58,7 @@
 import org.gvsig.fmap.dal.DataStoreNotification;
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.DataStoreProviderFactory;
+import org.gvsig.fmap.dal.StoresRepository;
 import org.gvsig.fmap.dal.exception.CloneException;
 import org.gvsig.fmap.dal.exception.CloseException;
 import org.gvsig.fmap.dal.exception.CreateException;
@@ -168,6 +169,9 @@
 import org.gvsig.tools.undo.command.Command;
 import org.gvsig.tools.util.HasAFile;
 import org.gvsig.tools.util.ResourcesStorage;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
+import org.gvsig.tools.util.UnmodifiableBasicSet;
+import org.gvsig.tools.util.UnmodifiableBasicSetChained;
 import org.gvsig.tools.visitor.VisitCanceledException;
 import org.gvsig.tools.visitor.Visitor;
 
@@ -331,32 +335,11 @@
     }
 
     @Override
-    public Iterator<DataStore> getChildren() {
+    public UnmodifiableBasicMap<String,DataStore> getChildren() {
         return this.provider.getChildren();
     }
 
     @Override
-    public DataStore getChild(String name) {
-        return this.provider.getChild(name);
-    }
-
-    @Override
-    public List<String> getChildrenNames() {
-        List<String> names = new ArrayList<>();
-        Iterator<DataStore> it = this.getChildren();
-        while(it.hasNext()) {
-            DataStore store = it.next();
-            names.add(store.getName());
-        }
-        return names;
-    }
-
-    @Override
-    public boolean hasChildren() {
-        return this.provider.hasChildren();
-    }
-
-    @Override
     public FeatureStoreProvider getProvider() {
         return this.provider;
     }
@@ -2934,13 +2917,8 @@
 
     @Override
     public ExpressionBuilder createExpressionBuilder() {
-        ExpressionBuilder builder = null;
-//        if( this.provider instanceof FeatureStoreProvider_v2 ) {
-//            builder = ((FeatureStoreProvider_v2)this.provider).createExpression();
-//        }
-//        if( builder==null ) {
-            builder = ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
-//        }
+        ExpressionBuilder builder;
+        builder = ExpressionEvaluatorLocator.getManager().createExpressionBuilder();
         return builder;
     }
 
@@ -3004,5 +2982,80 @@
     public ResourcesStorage getResourcesStorage() {
         return new DALResourcesStorage(this);
     }
+
+    @Override
+    public StoresRepository getStoresRepository() {
+        final StoresRepository mainRepository = this.dataManager.getStoresRepository();
+        StoresRepository repository = new StoresRepository() {
+            @Override
+            public void add(String name, DataStoreParameters parameters) {
+                mainRepository.add(name, parameters);
+            }
+
+            @Override
+            public void remove(String name) {
+                mainRepository.remove(name);
+            }
+
+            @Override
+            public DataStore get(String key) {
+                DataStore store = getChildren().get(key);
+                if( store != null ) {
+                    return store;
+                }
+                return mainRepository.get(key);
+            }
+
+            @Override
+            public boolean isEmpty() {
+                return getChildren().isEmpty() && mainRepository.isEmpty();
+            }
+
+            @Override
+            public boolean containsKey(String key) {
+                return getChildren().containsKey(key) || mainRepository.containsKey(key);
+            }
+
+            @Override
+            public Map<String, DataStore> toMap() {
+                return null;
+            }
+
+            @Override
+            public int size() {
+                return getChildren().size()+mainRepository.size();
+            }
+
+            @Override
+            public UnmodifiableBasicSet<String> keySet() {
+                UnmodifiableBasicMap<String, DataStore> children = getChildren();
+                if( children.isEmpty() ) {
+                    return mainRepository.keySet();
+                }
+                return new UnmodifiableBasicSetChained<>(
+                        children.keySet(), 
+                        mainRepository.keySet()
+                );
+            }
+
+            @Override
+            public Iterator<DataStore> iterator() {
+                final Iterator<String> it = this.keySet().iterator();
+                return new Iterator<DataStore>() {
+                    @Override
+                    public boolean hasNext() {
+                        return it.hasNext();
+                    }
+
+                    @Override
+                    public DataStore next() {
+                        String name = it.next();
+                        return get(name);
+                    }
+                };
+            }
+        };
+        return repository;
+    }
     
 }
\ No newline at end of file
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java	(revision 44259)
@@ -33,8 +33,19 @@
 import org.apache.commons.lang3.ArrayUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.Expression;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.SymbolTable;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.DataManager;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_CODE;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_LABEL;
+import static org.gvsig.fmap.dal.DataManager.DAL_FOREING_TABLE;
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.StoresRepository;
+import org.gvsig.fmap.dal.expressionevaluator.FeatureSymbolTable;
+import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureAttributeEmulator;
 import org.gvsig.fmap.dal.feature.FeatureAttributeGetter;
@@ -74,6 +85,7 @@
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
+@SuppressWarnings("UseSpecificCatch")
 public class DefaultFeatureAttributeDescriptor implements
         FeatureAttributeDescriptor, Persistent, DynField_v2, DynField_LabelAttribute {
 
@@ -128,6 +140,8 @@
     }
 
     protected DefaultFeatureAttributeDescriptor(FeatureType type) {
+        this();
+//        LOGGER.info(String.format("Created FeatureAttributeDescriptor [%08x].", this.hashCode()));
         setFeatureType(type);
         this.allowNull = true;
         this.dataType = null;
@@ -155,7 +169,9 @@
     protected DefaultFeatureAttributeDescriptor(
             DefaultFeatureAttributeDescriptor other
         ) {
+        this();
         copyFrom(other);
+//        LOGGER.info(String.format("Created FeatureAttributeDescriptor [%08x] [%s] (copy).", this.hashCode(), this.name));
     }
     
     @Override
@@ -230,6 +246,7 @@
             this.typeRef = null;
         } else {
             this.typeRef = new WeakReference(type);
+//            LOGGER.info(String.format("FeatureAttributeDescriptor[%08x] set FeatureType [%08x], ref [%08x].", this.hashCode(), type.hashCode(), typeRef.hashCode()));
         }
     }
     
@@ -346,6 +363,7 @@
     }
     
     public FeatureAttributeDescriptor setName(String name) {
+//        LOGGER.info(String.format("FeatureAttributeDescriptor[%08x] set name [%s].", this.hashCode(), name));
         this.name = name;
         return this;
     }
@@ -735,6 +753,60 @@
 
     @Override
     public DynObjectValueItem[] getAvailableValues() {
+        if( this.availableValues == null ) {
+            if( StringUtils.isBlank(this.getDataProfileName()) ) {
+                return null;
+            }
+            if( !StringUtils.equalsIgnoreCase(
+                    this.getDataProfileName(), 
+                    DataManager.DAL_SELECTABLE_FOREING_KEY) 
+                    ) {
+                return null;
+            }
+            Tags theTags = this.getTags();
+            if( theTags==null ) {
+                return null;
+            }
+            String foreingLabel = theTags.getString(DAL_FOREING_LABEL, null);
+            if( StringUtils.isBlank(foreingLabel) ) {
+                return null;
+            }
+            String foreingTableName = theTags.getString(DAL_FOREING_TABLE, null);
+            if( StringUtils.isBlank(foreingTableName) ) {
+                return null;
+            }
+            String foreingCodeName = theTags.getString(DAL_FOREING_CODE, null);
+            if( StringUtils.isBlank(foreingCodeName) ) {
+                return null;
+            }
+            try {
+                DataManager dataManager = DALLocator.getDataManager();
+                StoresRepository repository = this.getStore().getStoresRepository();
+                FeatureStore store = (FeatureStore) repository.get(foreingTableName);
+                if( store == null ) {
+                    LOGGER.warn("Can't locate store '"+foreingTableName+"' to get available values of field '"+this.getName()+"'.");
+                    return null;
+                }
+                        
+                Expression labelExpression = ExpressionUtils.createExpression(foreingLabel);
+                FeatureSymbolTable featureSymbolTable = dataManager.createFeatureSymbolTable();
+                SymbolTable symbolTable = featureSymbolTable.createParent();
+                
+                int count = (int) store.getFeatureCount();
+                DynObjectValueItem[] values = new DynObjectValueItem[count];
+                int n = 0;
+                for (Feature feature : store.getFeatureSet()) {
+                    featureSymbolTable.setFeature(feature);
+                    Object code = feature.get(foreingCodeName);
+                    Object label = labelExpression.execute(symbolTable);
+                    values[n++] = new DynObjectValueItem(code, Objects.toString(label, Objects.toString(code, "##ERROR##")));
+                }
+                this.availableValues = values;
+            } catch (Exception ex) {
+                LOGGER.warn("Can't get values from table '" + foreingTableName + "' for field '" + this.getName() + "'.", ex);
+                return null;
+            }
+        }
         return this.availableValues;
     }
 
@@ -1225,7 +1297,9 @@
         if( this.typeRef==null ) {
             return null;
         }
-        return (FeatureType) this.typeRef.get();
+        FeatureType ftype = (FeatureType) this.typeRef.get();
+//        LOGGER.info(String.format("FeatureAttributeDescriptor[%08x] get FeatureType [%08x], ref [%08x].", this.hashCode(), ftype.hashCode(), typeRef.hashCode()));
+        return ftype;
     }
 
     public FeatureAttributeDescriptor setInterval(Interval interval) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureQuery.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureQuery.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureQuery.java	(revision 44259)
@@ -332,6 +332,10 @@
 
     @Override
     public void setFilter(Expression filter) {
+        if( filter == null ) {
+            this.clearFilter();
+            return;
+        }
         Evaluator x = new DefaultExpressionEvaluator(filter);
         this.setFilter(x);
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureType.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureType.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureType.java	(revision 44259)
@@ -150,7 +150,9 @@
         DefaultFeatureAttributeDescriptor attr;
         while (iter.hasNext()) {
             attr = (DefaultFeatureAttributeDescriptor) iter.next();
-            copy.add(new DefaultFeatureAttributeDescriptor(attr));
+            DefaultFeatureAttributeDescriptor newattr = new DefaultFeatureAttributeDescriptor(attr);
+            newattr.setFeatureType(copy);
+            copy.add(newattr);
         }
         return copy;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/searchpanel/FeatureStoreSearchPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/searchpanel/FeatureStoreSearchPanel.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/searchpanel/FeatureStoreSearchPanel.java	(revision 44259)
@@ -0,0 +1,12 @@
+package org.gvsig.fmap.dal.swing.searchpanel;
+
+import org.gvsig.tools.swing.api.ActionListenerSupport;
+import org.gvsig.tools.swing.api.Component;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public interface FeatureStoreSearchPanel extends  Component, ActionListenerSupport {
+    
+}
